#include <sys/param.h>
#include <sys/systm.h>
#include <sys/kernel.h>
#include <sys/bus.h>

#include <sys/conf.h>
#include <sys/malloc.h>
#include <sys/module.h>
#include <sys/bus.h>

#include <dev/pci/pcivar.h>
#include <dev/pci/pcireg.h>

static void	vga_pci_identify(driver_t *driver, device_t parent);
static int	vga_pci_attach(device_t dev);
static int	vga_pci_probe(device_t dev);
static int	vga_pci_suspend(device_t dev);
static int	vga_pci_resume(device_t dev);

static device_method_t vga_pci_methods[] = {
	/* Device interface. */
	DEVMETHOD(device_identify,	vga_pci_identify),
	DEVMETHOD(device_probe,		vga_pci_probe),
	DEVMETHOD(device_attach,	vga_pci_attach),
	DEVMETHOD(device_suspend,	vga_pci_suspend),
	DEVMETHOD(device_resume,	vga_pci_resume),

	{ 0, 0 }
};

static driver_t vga_pci_driver = {
	"vga_pci",
	vga_pci_methods,
	0,
};

static devclass_t	vga_pci_devclass;

DRIVER_MODULE(vga_pci, pci, vga_pci_driver, vga_pci_devclass, 0, 0);

static void
vga_pci_identify(driver_t *driver, device_t parent)
{

        BUS_ADD_CHILD(parent, 255, "vga_pci", 0);
}

static int
vga_pci_probe(device_t dev)
{

	if (pci_get_class(dev) == PCIC_DISPLAY &&
	    pci_get_subclass(dev) == PCIS_DISPLAY_VGA) {
		device_set_desc(dev, "Generic PCI VGA");
		return (0);
	}

	return (ENXIO);
}

static int
vga_pci_attach(device_t dev)
{

	return (0);
}

static int
vga_pci_suspend(device_t dev)
{

	pci_set_powerstate(dev, PCI_POWERSTATE_D2);
	DELAY(100000);
	return (0);
}

static int
vga_pci_resume(device_t dev)
{

	pci_set_powerstate(dev, PCI_POWERSTATE_D0);
	return (0);
}

